import java.awt.Color;


public class TicTacToe {
	public static void main(String[] args)
	{
		int[] cells = new int[9];
		int turn = 0; boolean winner = false;
		int start = (int)(Math.random() * 2); 
		while(turn < 9 && !winner)
		{
			if((start + turn) % 2 == 0)
				winner = userTurn(cells);
			else
				winner = computerTurn(cells);
			drawTable(cells);
			turn++;
		}
		if(!winner && turn == 9)
			StdOut.println("Tie");
		else if(checkwin(cells, 1))
			StdOut.println("Congratulations, you win!");
		else
			StdOut.println("You lose, Game over..Try again..");
		
	}
	public static boolean userTurn(int[] cells)
	{
		StdOut.print("Give an integer between 0 and 8 inclusive: ");
		int num = StdIn.readInt();
		while(cells[num] != 0 && num >= 0 && num <9)
		{
			StdOut.println("Number already chosen, pick again.");
			StdOut.print("Give an integer between 0 and 8 inclusive: ");
			num = StdIn.readInt();
		}
		cells[num] = 1; 
		return checkwin(cells, 1);
	}
	public static boolean computerTurn(int[] cells)
	{
		int num = (int)(Math.random() * 9);
		while(cells[num] != 0)
			num = (int)(Math.random() * 9);
		StdOut.println("The computer chooses " + num);
		cells[num] = 2;
		return checkwin(cells, 2);
	}
	public static boolean checkwin(int[] cells, int id)
	{
		boolean win = false; 
		for(int x = 0; x < 3; x++)
		{
			win = true;
			for(int y = 0; y < 3; y++)
			{
				if(cells[3 * y + x] != id)
					win = false;
			}
			if(win)
				return win;
		}
		for(int y = 0; y < 3; y++)
		{
			win = true;
			for(int x = 0; x < 3; x++)
			{
				if(cells[3 * y + x] != id)
					win = false;
			}
			if(win)
				return win;
		}
		int x = 0; int y = 2;
		for(int i = 0; i < 3; i++)
		{
			if(cells[3 * y + x] != id)
				win = false;
			x++; y--;
		}
		if(win)
			return win;
		x = 2; y = 0;
		for(int i = 0; i < 3; i++)
		{
			if(cells[3 * x + y] != id)
				win = false;
			y++; x--;
		}
		if(cells[0]== id && cells[4] == id && cells[8]== id)
			win = true;
		return win;
	}
	public static void drawTable(int[] cells)
	{
		StdDraw.setXscale(0, 300);
		StdDraw.setYscale(0, 300);
		StdDraw.setPenColor(Color.black);
		StdDraw.square(150., 150., Math.sqrt(180000) / 2);
		for(int row = 50 ; row <= 250 ; row += 100)
		{
			for(int column = 50; column <= 250; column+= 100)
			{
				StdDraw.square(row * 1.0, column * 1.0 , Math.sqrt(10000) / 2.0);	
			}
		}
		for(int y = 50 ; y <= 250 ; y += 100)
		{
			for(int x = 50; x <= 250; x+= 100)
			{
				for(int i = 0; i < cells.length; i++)
				{
					if(i == 0) 
					{x = 50; y = 50;}
					else if(i == 1) 
					{x = 150; y = 50;}
					else if(i == 2) 
					{x = 250; y = 50;}
					else if(i == 3) 
					{x = 50; y = 150;}
					else if(i == 4) 
					{x = 150; y = 150;}
					else if(i == 5) 
					{x = 250; y = 150;}
					else if(i == 6) 
					{x = 50 ; y = 250;}
					else if(i == 7) 
					{x = 150 ; y = 250;}
					else if(i == 8) 
					{x = 250 ; y = 250;}

					if(cells[i] == 1)
					{
						StdDraw.line(x - 50, y - 50, x + 50, y + 50);
						StdDraw.line(x - 50, y + 50, x + 50, y - 50);
					}
					else if(cells[i] == 2)
					{
						StdDraw.filledCircle(x, y, 40.);
					}
				}
			}
		}	
	}
}
